﻿namespace TemporalSourceCover
{
    public struct Interval
    {
        public Time Min;
        public Time Max;

        public Time Size => new Time(Max.Value - Min.Value);

        public Interval(Time min, Time max)
        {
            Min = min;
            Max = max;
        }

        public void Include(Time time)
        {
            if (time < Min)
                Min = time;
            if (time > Max)
                Max = time;
        }
    }
}
