﻿using System.Diagnostics;

namespace TemporalSourceCover
{ 
    [DebuggerDisplay("{From.Id} -> {To.Id} @ {Time.Value}")]
    public sealed class TemporalGraphEdge
    {
        public readonly TemporalGraphVertex From;
        public readonly TemporalGraphVertex To;
        public readonly Time Time;

        public TemporalGraphEdge(TemporalGraphVertex from, TemporalGraphVertex to, Time time)
        {
            From = from;
            To = to;
            Time = time;
        }

        public void Deconstruct(out TemporalGraphVertex from, out TemporalGraphVertex to, out Time time)
        {
            from = From;
            to = To;
            time = Time;
        }
    }
}
