﻿using System.Collections.Generic;

namespace System.Linq
{
    public delegate bool ComparisonBool<in T>(T a, T b);

    public static class LinqExtensions
    {
        public static TOut? Aggregate<TIn, TOut>(this IEnumerable<TIn> values, Func<TIn, TOut> selector, ComparisonBool<TOut> comparisonFunc, TOut? defaultValue = default)
        {
            var enumerator = values.GetEnumerator();
            if (!enumerator.MoveNext())
                return defaultValue;

            TOut maxValue = selector.Invoke(enumerator.Current);
            while (enumerator.MoveNext())
            {
                var value = selector.Invoke(enumerator.Current);

                var select = comparisonFunc.Invoke(value, maxValue);
                if (select)
                {
                    maxValue = value;
                }
            }

            return maxValue!;
        }
    }
}
