﻿using System.Collections.Generic;

namespace System
{
    public static class StringExtensions
    {
        /// <summary>
        /// Splits the string using the specified function
        /// </summary>
        /// <param name="str"></param>
        /// <param name="splitController"></param>
        /// <returns></returns>
        public static IEnumerable<string> Split(this string str, Func<char, bool> splitController)
        {
            int partStart = 0;

            for (int i = 0; i < str.Length; i++)
            {
                if (!splitController.Invoke(str[i]))
                    continue;

                yield return str[partStart..i];
                partStart = i + 1;
            }

            yield return str[partStart..];
        }
    }
}
