﻿using System.Collections.Generic;

namespace TemporalSourceCover
{

    public static partial class DataReductionRules
    {
        public static readonly DataReductionRuleConfig Config = new DataReductionRuleConfig
        {
            ApplyReachabilityRules = true,
            ApplyTemporalRules = true,
        };

        public static Solution Apply(TemporalSourceCoverInstance instance, out List<DataReductionResult> reductions)
        {
            reductions = new List<DataReductionResult>();
            var solution = new Solution();

            bool didReduce;
            do
            {
                didReduce = false;
                if (Config.ApplyTemporalRules)
                {
                    didReduce |= ApplyTemporalSourceCoverDataReductions(instance, solution, reductions);
                }

                if (Config.ApplyReachabilityRules)
                {
                    didReduce |= ApplyReachabilityReductions(instance, solution, reductions);
                }
                //else
                //{
                //    instance.Reachability = instance.Graph.GetFullReachability();
                //}
            } while (didReduce);

            return solution;
        }
    }
}
